local loaded
local PATH = "hostmod.cfg"
local modname = "HOSTMOD"
local stubs = {"hornmod.cfg", "friendmod.cfg"}

local function loadconfig()
	if not loaded then
		local file = io.open(PATH, "r")
		if file == nil then
			file = io.open(PATH, "w")
			if not file then
				print("Uma "..modname.." configuracao nao pode ser gerada. Sem permissoes de escrita?")
				print("[Se voce estiver vendo isso no console do servidor, nao tem problema.]")
				loaded = true
			end
			print("\130Uma "..modname.." configuracao foi criada em luafiles/"..PATH..".")
			print("\130Os comandos colocados la serao executados quando voce entrar em um servidor usando "..modname..".")
			file:write("// Coloque os comandos de "..modname.." abaixo, um por linha!")
			file:close()
		else
			if not consoleplayer then
				print("Tentei ler "..PATH..", mas nao ha nenhum player para executa-lo.")
				print("[Se voce estiver vendo isso no console do servidor, nao tem problema.]")
				loaded = true
				return
			end
			print("\130Uma "..modname.." configuracao foi encontrada. Carregando, aguarde...")
			local buf = file:read()
			while buf
				COM_BufInsertText(consoleplayer, buf)
				buf = file:read()
			end
			file:close()
		end
		
		for k,v in ipairs(stubs)
			local stub = io.open(v, "r")
			if stub == nil then
				stub = io.open(v, "w")
				stub:write("// Configuracao de stub para reduzir a paralisacao da pesquisa de arquivos. Gerado por "..modname..".")
				stub:close()
			end
		end
		
		loaded = true
	end
end

addHook("ThinkFrame", loadconfig)
addHook("IntermissionThinker", loadconfig)
addHook("VoteThinker", loadconfig)