local hostmod_customcheck = CV_RegisterVar({
	name = "hm_customcheck",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hostmod_customcheck1 = CV_RegisterVar({
	name = "hm_customcheck_1",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hostmod_customcheck2 = CV_RegisterVar({
	name = "hm_customcheck_2",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hostmod_customcheck3 = CV_RegisterVar({
	name = "hm_customcheck_3",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local customvals = {hostmod_customcheck1, hostmod_customcheck2, hostmod_customcheck3}
local btns = {BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3}

-- this is the part where i reveal that i have no idea how boolean order of operations works
addHook("ThinkFrame", function()
	if not hostmod_customcheck.value then return end
	for p in players.iterate
		if p.HMcc == nil then
			p.HMcc = false
			p.HMccf = {false, false, false}
			p.HMccalert = 0
			p.HMcccount = 0
		end
		p.HMccalert = max(0, $ - 1)
		
		local didit = true
		for k, v in ipairs(p.HMccf)
			if (not v) and customvals[k].value  then
				if p.cmd.buttons & btns[k] then
					p.HMccf[k] = true
					S_StartSound(nil, sfx_kc50, p)
				else
					didit = false
				end
			end
		end
		
		if didit and not p.HMcc then
			p.HMcc = true
			S_StartSound(nil, sfx_cdpcm4, p)
		end
		
		if (not p.HMcc) and (not p.spectator) then
			p.spectator = true
			if p.HMcccount == 0 then
				p.HMcccount = 1
			else
				CONS_Printf(p, "Voce nao podera participar ate passar pela checagem dos custom buttons.")
				S_StartSound(nil, sfx_s3kb2, p)
				p.HMccalert = TICRATE * 1
				p.HMcccount = $ + 1
			end
		end
	end
end)

-- HUD
local function drawStringCenter(v, xx, yy, ss, ff, tt)
	local ww = v.stringWidth(ss, ff, tt)
	v.drawString(xx - (ww / 2), yy, ss, ff, tt)
end

local function calcStringCenter(v, xx, yy, ss, ff, tt)
	local ww = v.stringWidth(ss, ff, tt)
	return xx - (ww / 2)
end

local function buttonstring(x, p)
	if not customvals[x].value then
		return ""
	end
	if p.HMccf[x] then
		return "CUSTOM "..x.."   \131OK!"
	end
	return "CUSTOM "..x.."   \134..."
end

local function buttonflag(x, p)
	if p.HMccf[x] then return 0 end
	return V_50TRANS
end

hud.add(function(v, p, c)
	if not hostmod_customcheck.value then return end
	if p.HMcc == nil then return end
	if p.HMcc then return end
	local flags = V_SNAPTOTOP|V_ALLOWLOWERCASE
	v.fadeScreen(0xFF00, 16)	-- fade the screen
	local tx = 25 -- Top X
	local ty = 15 -- Left Y
	local bx = 295 -- Bottom X
	local by = 100 -- Right Y
	local brd = 2 -- Border
	local pad = 4 -- Padding
	v.drawFill(tx, ty, bx-tx, by-ty, 31|flags)
	v.drawFill(tx+brd, ty+brd, bx-tx-brd-brd, by-ty-brd-brd, 207|flags)
	drawStringCenter(v, (bx+tx)/2, ty+pad, "Este modo de jogo usa \130custom buttons\128.", flags, "thin")
	v.drawFill(tx, ty+pad+12-brd, bx-tx, 1+brd, 31|flags)
	drawStringCenter(v, (bx+tx)/2, ty+pad+15, "Antes de entrar, certifique-se de que esta mapeado", flags, "small")
	drawStringCenter(v, (bx+tx)/2, ty+pad+20, "e pode pressionar confortavelmente os seguintes botoes.", flags, "small")
	drawStringCenter(v, (bx+tx)/2, ty+pad+25, "Primeira vez? Aperte ESC > Options > Control Setup...", flags|V_50TRANS, "small")
	
	if splitscreen then
		drawStringCenter(v, (bx+tx)/2, ty+pad+35, "\130Essa tela e toda estragada no modo splitscreen, foi mal.", flags, "small")
		drawStringCenter(v, (bx+tx)/2, ty+pad+40, "\130Todos os jogadores devem apertar botoes personalizados ate essa tela sumir.", flags, "small")
	else
		local fug = calcStringCenter(v, (bx+tx)/2, ty+pad+35, "CUSTOM 1   \131OK!", flags)
		v.drawString(fug, ty+pad+35, buttonstring(1, p), flags|buttonflag(1, p))
		v.drawString(fug, ty+pad+45, buttonstring(2, p), flags|buttonflag(2, p))
		v.drawString(fug, ty+pad+55, buttonstring(3, p), flags|buttonflag(3, p))
	end
	
	local fugs = 0
	if p.HMccalert and (not (leveltime % 2)) then fugs = V_YELLOWMAP end
	drawStringCenter(v, (bx+tx)/2, by-pad-5, "\134Voce pode entrar depois de pressionar todos esses botoes pelo menos uma vez.", flags|fugs, "small")
end)